'
' Application of API function GetOpenFileNameW function (Comdlg32.dll)
'
' https://learn.microsoft.com/en-us/windows/win32/api/commdlg/nf-commdlg-getopenfilenamew
'
' requires COM server module DynaLib (http://eriedel.info/)
'
Dim arg, cb, dlgtitle, fname, fnamecc, obj, ofnstruct, x

Set obj = CreateObject("DynaLib.Caller")
cb = 88
ofnstruct = String(cb / 2, 0)
obj.InsertNumber ofnstruct, cb, 1

fnamecc = 256
fname = obj.CreateString(fnamecc)
obj.InsertNumber ofnstruct, fname, 29
obj.InsertNumber ofnstruct, fnamecc, 33

dlgtitle = obj.CreateString(0, "Open File Name Sample")
obj.InsertNumber ofnstruct, dlgtitle, 49

arg = Array(ofnstruct)
x = obj.CallFunc("Comdlg32.dll", "GetOpenFileNameW", arg)
Set obj = Nothing

If x Then
    MsgBox obj.StringFromPointer(fname)
Else
    MsgBox "Sorry, function call failed."
End If

Wscript.Quit


